/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.bpel.ode.smx.utils;

import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.dom4j.DocumentFactory;
import org.dom4j.Element;
import org.dom4j.Namespace;
import org.dom4j.Node;
import org.dom4j.io.SAXReader;
import org.dom4j.xpath.DefaultXPath;


public class OdeSmxUtil {

	public static Map<String, String> getNameSpaceURI() {

		Map<String, String> nsURIMap = new HashMap<String, String>();
		nsURIMap.put("apachesoap", "http://xml.apache.org/xml-soap");
		nsURIMap.put("impl", "http://beans.demo.spagic.eng.it");
		nsURIMap.put("intf", "http://beans.demo.spagic.eng.it");
		nsURIMap.put("wsdl", "http://schemas.xmlsoap.org/wsdl/");
		nsURIMap.put("wsdlsoap", "http://schemas.xmlsoap.org/wsdl/soap/");
		nsURIMap.put("xsd", "http://www.w3.org/2001/XMLSchema");
		return nsURIMap;
	}
	
	public static String enrichWSDL(String absoluteWSDLFilePath) {
		
		FileOutputStream fos = null;
		try {
			SAXReader reader = new SAXReader(false);
			org.dom4j.Document document = reader.read(absoluteWSDLFilePath);

			// recursively walk and modify document
			DocumentFactory aDocumentFactory = reader.getDocumentFactory();
			
			String xPath = "/wsdl:definitions/wsdl:service/wsdl:port";
			org.dom4j.XPath xPathExpression = new DefaultXPath(xPath);
			xPathExpression.setNamespaceURIs(getNameSpaceURI());
			List<Node> wsdlPortNodeList  = xPathExpression.selectNodes(document);
			
			Namespace smxNs = aDocumentFactory.createNamespace("smix", "http://servicemix.org/wsdl/jbi/");
			document.getRootElement().addNamespace(smxNs.getPrefix(), smxNs.getURI());

			
			for ( Node wsdlPort : wsdlPortNodeList){ 
		        	  Element smxElement = ((Element)wsdlPort).addElement(org.dom4j.QName.get("endpoint", smxNs)).addAttribute("role", "provider").addAttribute("defaultMep","in-out");
			}
			return document.asXML();
		} catch (Throwable t) {
			t.printStackTrace();
			return null;
		}finally{
			try{
				//fos.close();
			}catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	
	public static String getRelativeFileName(String original){
		String relPath = original;
		if (original.indexOf("/") > 0)
			relPath = relPath.substring(original.lastIndexOf("/") + 1);
		if (original.indexOf("\\") > 0)
			relPath = relPath.substring(original.lastIndexOf("\\") + 1);
		return relPath;
	}
	
	public static String getOneStringFromStringArray(List<String> listString){
		StringBuffer sb = new StringBuffer("");
		for ( Iterator it = listString.iterator(); it.hasNext();){
			sb.append((String)it.next());
			if (it.hasNext()) sb.append(";");
		}
		return sb.toString();
	}
	
	public static List<String> getListFromOneString(String oneString) {
		return ((oneString != null) && (oneString.length() != 0)) ?
					Arrays.asList(oneString.split(";")) : new ArrayList<String>(0);
	}
}
