/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.bpel.ode.smx.utils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jet.JET2Platform;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;



public class TestBPELDeployAction implements IObjectActionDelegate {
	
	private IFile bpelFile = null;
	
	
	
	/**
	 * Constructor for Action1.
	 */
	public TestBPELDeployAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		
		Map<String, String> variables = new HashMap<String, String>();	

		List<String> absoluteWSDLList = new ArrayList<String>();
		
		absoluteWSDLList.add("C:/Progetti/Spagic/demo/OrderManagement/Bpel/StoreProcess/Logistic.wsdl");
		absoluteWSDLList.add("C:/Progetti/Spagic/demo/OrderManagement/Bpel/StoreProcess/Store.wsdl");
		absoluteWSDLList.add("C:/Progetti/Spagic/demo/OrderManagement/Bpel/StoreProcess/Supplier.wsdl");
		
		String processName = "StoreProcess";
		variables.put("processName",processName );
		variables.put("absoluteWSDLList", OdeSmxUtil.getOneStringFromStringArray(absoluteWSDLList));
		variables.put("org.eclipse.jet.resource.project.name",bpelFile.getProject().getName());

		System.out.println("About to call common generate method in JET project");
		IStatus status = JET2Platform.runTransformOnObject("org.spagic.bpel.ode.smx", 
				null, variables,new NullProgressMonitor() );

		
		IFolder iFolder = bpelFile.getProject().getFolder("Bpel/"+processName + "-sa");
		ZipUtils.getDefault().zipFolderAndSubFolder(iFolder);
		/*
		for (String aFolder : JBIJetUtils.getFolders()){
			IFolder iFolder = imFile.getProject().getFolder(aFolder);
			ZipUtils.getDefault().zipFolderAndSubFolder(iFolder);
		}
		*/
		
		MessageDialog.openInformation(new Shell(), "Spagic", "Deploy Completed");
	}

	public final void selectionChanged(final IAction action,
			final ISelection selection) {
		
		setBpelFile((IFile) ((StructuredSelection) selection)
				.getFirstElement());
	}

	public IFile getBpelFile() {
		return bpelFile;
	}

	public void setBpelFile(IFile bpelFile) {
		this.bpelFile = bpelFile;
	}

			
}
