package org.spagic.bpmn.diagram.palette.toolentries;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.diagram.part.BpmnDiagramEditorPlugin;

public abstract class AbstractToolEntry implements IToolEntry {
	
	    

	    public static final String getImgPath(String objSize, String fileName, String extension) {
	        return START_IMG_URI + objSize + fileName + "." + extension;
	    }
	    public static final ImageDescriptor findImgDescr(String objSize, String fileName) {
	        return BpmnDiagramEditorPlugin.imageDescriptorFromPlugin(STP_BPMN_EDIT_PLUGIN_ID,
	                getImgPath(objSize, fileName, "png"));
	    }
	    public static final ImageDescriptor findSmallImgDescr(String fileName) {
	        return BpmnDiagramEditorPlugin.imageDescriptorFromPlugin(STP_BPMN_EDIT_PLUGIN_ID,
	                getImgPath(OBJ_16, fileName, "png"));
	    }
	    public static final ImageDescriptor findMediumImgDescr(String fileName) {
	        return BpmnDiagramEditorPlugin.imageDescriptorFromPlugin(STP_BPMN_EDIT_PLUGIN_ID,
	                getImgPath(OBJ_24, fileName, "png"));
	    }
	    public static final ImageDescriptor findLargeImgDescr(String fileName) {
	        return BpmnDiagramEditorPlugin.imageDescriptorFromPlugin(STP_BPMN_EDIT_PLUGIN_ID,
	                getImgPath(OBJ_32, fileName, "png"));
	    }
	    
	    public static final ImageDescriptor findSmallToolImgDescr(String fileName) {
	        return BpmnDiagramEditorPlugin.imageDescriptorFromPlugin(STP_BPMN_EDIT_PLUGIN_ID,
	                getImgPath(TOOL_16, fileName, "png"));
	    }
	    public static final ImageDescriptor findMediumToolImgDescr(String fileName) {
	        return BpmnDiagramEditorPlugin.imageDescriptorFromPlugin(STP_BPMN_EDIT_PLUGIN_ID,
	                getImgPath(TOOL_24, fileName, "png"));
	    }
	    public static final ImageDescriptor findLargeToolImgDescr(String fileName) {
	        return BpmnDiagramEditorPlugin.imageDescriptorFromPlugin(STP_BPMN_EDIT_PLUGIN_ID,
	                getImgPath(TOOL_32, fileName, "png"));
	    }
}
