package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.ActivityType;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class DatabasedInclusiveCreationTool extends AbstractToolEntry {

	public ToolEntry createTool() {
	
		        ImageDescriptor smallImage = findSmallImgDescr(GATEWAY_DATABASED_INCLUSIVE);
		        ImageDescriptor largeImage = findLargeImgDescr(GATEWAY_DATABASED_INCLUSIVE);

		        final List elementTypes = new ArrayList();
		        IElementTypeEx activity = ElementTypeEx.wrap(
		                BpmnElementTypes.Activity_2001,
		                ActivityType.GATEWAY_DATA_BASED_INCLUSIVE_LITERAL.getName());
		        elementTypes.add(activity);

		        ToolEntry result = new NodeToolEntry("Inclusive Data-based", //$NON-NLS-1$
		                "Create an inclusive data-based gateway", smallImage, largeImage, //$NON-NLS-1$
		                elementTypes) {
		        };

		        return result;
		    }

}
