package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.ActivityType;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class EndCompensationCreationTool extends AbstractToolEntry {

	public ToolEntry createTool() {
		
	        ImageDescriptor smallImage = findSmallImgDescr(END_COMPENSATION);
	        ImageDescriptor largeImage = findLargeImgDescr(END_COMPENSATION);

	        final List elementTypes = new ArrayList();
	        IElementTypeEx activity = ElementTypeEx
	                .wrap(
	                        BpmnElementTypes.Activity_2001,
	                        ActivityType.EVENT_END_COMPENSATION_LITERAL.getName());
	        elementTypes.add(activity);

	        ToolEntry result = new NodeToolEntry("Compensation End", //$NON-NLS-1$
	                "Create a compensation end event", smallImage, largeImage, //$NON-NLS-1$
	                elementTypes) {
	        };

	        return result;
	    }

}
