package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.ActivityType;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class EndTerminateCreationTool extends AbstractToolEntry{

	public ToolEntry createTool() {
		        ImageDescriptor smallImage = findSmallImgDescr(END_TERMINATE);
		        ImageDescriptor largeImage = findLargeImgDescr(END_TERMINATE);

		        final List elementTypes = new ArrayList();
		        IElementTypeEx activity = ElementTypeEx.wrap(
		                        BpmnElementTypes.Activity_2001,
		                        ActivityType.EVENT_END_TERMINATE_LITERAL.getName());
		        elementTypes.add(activity);

		        ToolEntry result = new NodeToolEntry("Terminate", //$NON-NLS-1$
		                "Create a terminate event", smallImage, largeImage, //$NON-NLS-1$
		                elementTypes) {
		        };

		        return result;
		    }

}
