package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.part.Messages;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class EventbasedExclusiveCreationTool extends AbstractToolEntry {

	public ToolEntry createTool() {
		
		        ImageDescriptor smallImage = findSmallImgDescr(GATEWAY_EVENT_BASED);
		        ImageDescriptor largeImage = findLargeImgDescr(GATEWAY_EVENT_BASED);

		        final List elementTypes = new ArrayList();
		        IElementTypeEx activity = ElementTypeEx
		                .wrap(
		                        BpmnElementTypes.Activity_2001,
		                        Messages
		                                .getString("BpmnPaletteFactory._UI_ActivityType_GatewayEventBasedExclusive_literal")); //$NON-NLS-1$

		        elementTypes.add(activity);

		        ToolEntry result = new NodeToolEntry("Exclusive Event-based", //$NON-NLS-1$
		                "Create an exclusive event-based gateway", smallImage, largeImage, //$NON-NLS-1$
		                elementTypes) {
		        };

		        return result;
		    }

}
