package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.ActivityType;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class IntermediateCancelCreationTool extends AbstractToolEntry{

	public ToolEntry createTool() {
		
		        ImageDescriptor smallImage = findSmallImgDescr(INTERMEDIATE_CANCEL);
		        ImageDescriptor largeImage = findLargeImgDescr(INTERMEDIATE_CANCEL);

		        final List elementTypes = new ArrayList();
		        IElementTypeEx activity = ElementTypeEx.wrap(
		                        BpmnElementTypes.Activity_2003,
		                        ActivityType.EVENT_INTERMEDIATE_CANCEL_LITERAL.getName());
		        elementTypes.add(activity);

		        ToolEntry result = new NodeToolEntry("Cancel intermediate", //$NON-NLS-1$
		                "Create a cancel intermediate event", smallImage, largeImage, //$NON-NLS-1$
		                elementTypes) {
		        };

		        return result;
		    }

}
