package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.ActivityType;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class IntermediateMessageCreationTool extends AbstractToolEntry {

	public ToolEntry createTool() {
		
	        ImageDescriptor smallImage = findSmallImgDescr(INTERMEDIATE_MESSAGE);
	        ImageDescriptor largeImage = findLargeImgDescr(INTERMEDIATE_MESSAGE);

	        final List elementTypes = new ArrayList();
	        IElementTypeEx activity = ElementTypeEx.wrap(
	                        BpmnElementTypes.Activity_2001,
	                        ActivityType.EVENT_INTERMEDIATE_MESSAGE_LITERAL.getName());

	        elementTypes.add(activity);

	        ToolEntry result = new NodeToolEntry("Message Intermediate", //$NON-NLS-1$
	                "Create a message intermediate event", smallImage, //$NON-NLS-1$
	                largeImage, elementTypes) {
	        };

	        return result;
	    }

}
