package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.ActivityType;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class IntermediateTimerCreationTool extends AbstractToolEntry {

	public ToolEntry createTool() {
		
	        ImageDescriptor smallImage = findSmallImgDescr(INTERMEDIATE_TIMER);
	        ImageDescriptor largeImage = findLargeImgDescr(INTERMEDIATE_TIMER);

	        final List elementTypes = new ArrayList();
	        IElementTypeEx activity = ElementTypeEx.wrap(
	                BpmnElementTypes.Activity_2001,
	                ActivityType.EVENT_INTERMEDIATE_TIMER_LITERAL.getName());
	        IElementTypeEx activity2 = ElementTypeEx.wrap(
	                BpmnElementTypes.Activity_2003,
	                ActivityType.EVENT_INTERMEDIATE_TIMER_LITERAL.getName());
	        elementTypes.add(activity);
	        elementTypes.add(activity2);

	        ToolEntry result = new NodeToolEntry("Timer Intermediate", //$NON-NLS-1$
	                "Create a timer intermediate event", smallImage, largeImage, //$NON-NLS-1$
	                elementTypes) {
	        };

	        return result;
	    }


}
