package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.GraphicalViewer;
import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gef.tools.AbstractTool;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IPrimaryEditPart;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.stp.bpmn.palette.IStickableToolEntry;

/**
 * @generated
 */
public class LinkToolEntry extends ToolEntry implements IStickableToolEntry {

    /**
     * @generated
     */
    private final List relationshipTypes;
    
    private boolean _isSticky = true;

    /**
     * @generated
     */
    public LinkToolEntry(String title, String description,
            ImageDescriptor smallIcon, ImageDescriptor largeIcon,
            List relationshipTypes) {
        super(title, description, smallIcon, largeIcon);
        this.relationshipTypes = relationshipTypes;
    }
    
    /**
     * @return true if in sticky mode
     * where the tool created is not unloaded once it 
     * has been used.
     */
    public boolean isSticky() {
        return _isSticky;
    }
    
    /**
     * @param isSticky True if in sticky mode
     * where the tool created is not unloaded once it 
     * has been used.
     */
    public void setIsSticky(boolean isSticky) {
        _isSticky = isSticky;
    }


    /**
     * @notgenerated
     */
    public Tool createTool() {
        Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes) {
            
            /**
             * Creates a connection between the two select shapes. edit parts.
             */
            protected void createConnection() {
                if (getCurrentViewer() instanceof GraphicalViewer) {
                    super.createConnection();
                }
                //nothing we are probably still above the palette
            }

            
            /**
             * Method selectAddedObject. Select the newly added connection
             */
            protected void selectAddedObject(EditPartViewer viewer,
                    Collection objects) {
                final List editparts = new ArrayList();
                final EditPart[] primaryEP = new EditPart[1];
                for (Iterator i = objects.iterator(); i.hasNext();) {
                    Object object = i.next();
                    if (object instanceof IAdaptable) {
                        Object editPart = viewer.getEditPartRegistry().get(
                                ((IAdaptable) object)
                                        .getAdapter(View.class));

                        if (editPart instanceof IPrimaryEditPart) {
                            editparts.add(editPart);
                        }

//uncomment to put shape in direct edit mode.
//                        // Priority is to put a shape into direct edit mode.
//                        if (editPart instanceof ShapeEditPart) {
//                            primaryEP[0] = (ShapeEditPart) editPart;
//                        }
                    }
                }

                if (!editparts.isEmpty()) {
                    viewer.setSelection(new StructuredSelection(editparts));

                    // next section of code was removed as EDGE-1020 fix:
                    // turn off auto edit mode after
                    // connection creation
                    
                    
                    
                }
            }
        };
        
        tool.setProperties(getToolProperties());
        ((AbstractTool)tool).setUnloadWhenFinished(!isSticky());
        return tool;
    }
}