package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gef.tools.AbstractTool;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.palette.IStickableToolEntry;
import org.eclipse.stp.bpmn.tools.UnspecifiedActivityTypeCreationToolEx;

/**
 * @generated not implements IStickableToolEntry.
 */
public class NodeToolEntry extends ToolEntry implements IStickableToolEntry {

    /**
     * @generated not
     */
    private List elementTypes;
    
    private boolean _isSticky = false;
    
    /**
     * @generated not
     */
    public NodeToolEntry(String title, String description,
            ImageDescriptor smallIcon, ImageDescriptor largeIcon,
            List elementTypes) {
        super(title, description, smallIcon, largeIcon);
        this.elementTypes = elementTypes;
    }
    
    /**
     * @generated not
     */
    public NodeToolEntry(String title, String description,
            ImageDescriptor smallIcon, ImageDescriptor largeIcon,
            Class className) {
        super(title, description, smallIcon, largeIcon, className);
    }
    /**
     * @return true if in sticky mode
     * where the tool created is not unloaded once it 
     * has been used.
     */
    public boolean isSticky() {
        return _isSticky;
    }
    
    /**
     * @param isSticky True if in sticky mode
     * where the tool created is not unloaded once it 
     * has been used.
     */
    public void setIsSticky(boolean isSticky) {
        _isSticky = isSticky;
    }

    /**
     * @generated not
     * if no element types are provided, try 
     * the super implementation.
     */
    public Tool createTool() {
        if (elementTypes == null) {
            return super.createTool();
        }
        AbstractTool tool = new UnspecifiedActivityTypeCreationToolEx(
                elementTypes, !_isSticky);
        tool.setProperties(getToolProperties());
        return tool;
    }
}
