package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.ActivityType;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class ParallelCreationTool extends AbstractToolEntry {

	public ToolEntry createTool() {
		
	        ImageDescriptor smallImage = findSmallImgDescr(GATEWAY_PARALLEL);
	        ImageDescriptor largeImage = findLargeImgDescr(GATEWAY_PARALLEL);

	        final List elementTypes = new ArrayList();
	        IElementTypeEx activity = ElementTypeEx.wrap(
	                    BpmnElementTypes.Activity_2001,
	                    ActivityType.GATEWAY_PARALLEL_LITERAL.getName());

	        elementTypes.add(activity);

	        ToolEntry result = new NodeToolEntry("Parallel", "Create a parallel gateway", //$NON-NLS-1$ //$NON-NLS-2$
	                smallImage, largeImage, elementTypes) {
	        };

	        return result;
	    }


}
