package org.spagic.bpmn.diagram.palette.toolentries;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.ActivityType;
import org.eclipse.stp.bpmn.commands.ElementTypeEx;
import org.eclipse.stp.bpmn.commands.IElementTypeEx;
import org.eclipse.stp.bpmn.diagram.providers.BpmnElementTypes;

public class StartMessageCreationTool extends AbstractToolEntry {

	public ToolEntry createTool() {
	
	        ImageDescriptor smallImage = findSmallImgDescr(START_MESSAGE);
	        ImageDescriptor largeImage = findLargeImgDescr(START_MESSAGE);

	        final List elementTypes = new ArrayList();
	        IElementTypeEx activity = ElementTypeEx
	                .wrap(
	                        BpmnElementTypes.Activity_2001,
	                        ActivityType.EVENT_START_MESSAGE_LITERAL.getName());
	        elementTypes.add(activity);

	        ToolEntry result = new NodeToolEntry("Message Start", //$NON-NLS-1$
	                "Create a message start event", smallImage, largeImage, //$NON-NLS-1$
	                elementTypes) {
	        };

	        return result;
	    }

}
