package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_wsdlgen implements JET2Template {

    public _jet_wsdlgen() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
 
	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	ServiceBinding sb = (ServiceBinding)context.getVariable("servicebinding");
	boolean inOut = sb.getName().equalsIgnoreCase("JBI-HTTPInputOutputBindingComponent"); 
	
	
	// spagic Namespace
   	String spagicNSPrefix = "spagic";
   	String spagicNSValue = "urn:eng:spagic";
   	
   	// Process Namespace
   	String targetNSPrefix = SpagicUtils.getNameSpacePrefixForProcess(aProcess);
   	String targetNSValue = SpagicUtils.getNameSpaceForProcess(aProcess);
   	
   	String url = JBIJetUtils.getRequiredPropertyValue(aStep, "Uri");
	String portTypeName = SpagicUtils.getStepLocalNamePart(aProcess, aStep);
	String bindingName = portTypeName + "Binding";
	String serviceName = SpagicUtils.getStepLocalNamePart(aProcess, destinationStep);

        out.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<wsdl:definitions ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\txmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\txmlns:");  //$NON-NLS-1$        
        out.write(targetNSPrefix);
        out.write("=\"");  //$NON-NLS-1$        
        out.write(targetNSValue);
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\txmlns:");  //$NON-NLS-1$        
        out.write(spagicNSPrefix);
        out.write("=\"");  //$NON-NLS-1$        
        out.write(spagicNSValue);
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\txmlns:wsdlsoap=\"http://schemas.xmlsoap.org/wsdl/soap/\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\txmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\ttargetNamespace=\"");  //$NON-NLS-1$        
        out.write(targetNSValue);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<wsdl:types>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<xsd:schema elementFormDefault=\"qualified\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t    \t\ttargetNamespace=\"");  //$NON-NLS-1$        
        out.write(spagicNSValue);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<xsd:element name=\"payload\" type=\"xsd:anyType\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<xsd:element name=\"response\" type=\"xsd:anyType\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</xsd:schema>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</wsdl:types>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("\t\t<wsdl:message name=\"msgRequest\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<wsdl:part element=\"");  //$NON-NLS-1$        
        out.write(spagicNSPrefix);
        out.write(":payload\" name=\"in\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</wsdl:message>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("\t\t<wsdl:message name=\"msgResponse\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<wsdl:part element=\"");  //$NON-NLS-1$        
        out.write(spagicNSPrefix);
        out.write(":response\" name=\"out\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</wsdl:message>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<wsdl:portType name=\"");  //$NON-NLS-1$        
        out.write(portTypeName);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<wsdl:operation name=\"run\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<wsdl:input message=\"");  //$NON-NLS-1$        
        out.write(targetNSPrefix);
        out.write(":msgRequest\" name=\"inRequest\"/>");  //$NON-NLS-1$        
        out.write(NL);         
if (inOut){
        out.write("\t\t\t\t<wsdl:output message=\"");  //$NON-NLS-1$        
        out.write(targetNSPrefix);
        out.write(":msgResponse\" name=\"outResponse\"/>");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</wsdl:operation>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</wsdl:portType>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("\t<wsdl:binding name=\"");  //$NON-NLS-1$        
        out.write(bindingName);
        out.write("\" type=\"");  //$NON-NLS-1$        
        out.write(targetNSPrefix);
        out.write(":");  //$NON-NLS-1$        
        out.write(portTypeName);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<wsdlsoap:binding style=\"document\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t  transport=\"http://schemas.xmlsoap.org/soap/http\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<wsdl:operation name=\"run\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<wsdlsoap:operation soapAction=\"\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<wsdl:input name=\"inRequest\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t<wsdlsoap:body use=\"literal\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t</wsdl:input>");  //$NON-NLS-1$        
        out.write(NL);         
if (inOut){
        out.write("\t\t\t\t<wsdl:output name=\"outResponse\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t<wsdlsoap:body use=\"literal\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t</wsdl:output>");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</wsdl:operation>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t</wsdl:binding>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("\t<wsdl:service name=\"");  //$NON-NLS-1$        
        out.write(serviceName);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<wsdl:port binding=\"");  //$NON-NLS-1$        
        out.write(targetNSPrefix);
        out.write(":");  //$NON-NLS-1$        
        out.write(bindingName);
        out.write("\" name=\"");  //$NON-NLS-1$        
        out.write(portTypeName);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<wsdlsoap:address location=\"");  //$NON-NLS-1$        
        out.write(url);
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</wsdl:port>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t</wsdl:service>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</wsdl:definitions>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
    }
}
