package org.spagic.im.out.jbi.smx.wsdl.actions;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.jet.JET2Platform;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.stp.im.ImPackage;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;


/**
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public class GenerateWSDLAction implements IObjectActionDelegate {

	/** the selected file. */
	private IFile imFile = null;

	
	public IFile getImFile() {
		return imFile;
	}

	public void setImFile(IFile imFile) {
		this.imFile = imFile;
	}
	/**
	 * Constructor for GenerateJarFileAction.
	 */
	public GenerateWSDLAction() {
		super();
	}

	/**
	 * the getter fileselected function.
	 * 
	 * @return IFile
	 */
	public final IFile getFileSelected() {
		return imFile;
	}

	/**
	 * The setter file selected function.
	 * 
	 * @param filePath :
	 *            the file
	 */
	public final void setFileSelected(final IFile filePath) {
		this.imFile = filePath;
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 * @param action
	 *            the action proxy that handles the presentation portion of the
	 *            action
	 * @param targetPart
	 *            the new part target
	 */
	public final void setActivePart(final IAction action,
			final IWorkbenchPart targetPart) {
	}

	
	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		final Shell shell = new Shell();
		
		// Read the bpmn emf model
		ResourceSet resourceSetIM = new ResourceSetImpl();
		URI uri = URI.createFileURI(imFile.getFullPath().toString());
		
		// Force Package Registration
		ImPackage imPackage = ImPackage.eINSTANCE;
		
		// Load On Demand = true 
		Resource resourceIM = resourceSetIM.getResource(uri, true);
		
		Map<String, String> variables = new HashMap<String, String>();

		variables.put("org.eclipse.jet.resource.project.name",imFile.getProject().getName());

		System.out.println("About to call common generate method in JET project");
		
		IStatus status = JET2Platform.runTransformOnObject("org.spagic.im.out.jbi.smx.wsdl", 
				resourceIM, variables,new NullProgressMonitor() );
		
		MessageDialog.openInformation(new Shell(), "Spagic", "WSDL Generation Completed ");		
	
	}

	public final void selectionChanged(final IAction action,
			final ISelection selection) {
		
		setImFile((IFile) ((StructuredSelection) selection)
				.getFirstElement());
	}

	

}
