package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIJDBCPollerBindingComponent implements JET2Template {

    public _jet_JBIJDBCPollerBindingComponent() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String rowsForEachMessage = JBIJetUtils.getOptionalPropertyValue(aStep,"RowsForEachMessage", "");
	boolean rowNameAsAttribute = Boolean.valueOf(JBIJetUtils.getOptionalPropertyValue(aStep, "RowNameAsAttribute", "true"));
	boolean colNameAsAttribute = Boolean.valueOf(JBIJetUtils.getOptionalPropertyValue(aStep, "ColNameAsAttribute", "true"));
	boolean valueAsAttribute = Boolean.valueOf(JBIJetUtils.getOptionalPropertyValue(aStep, "ValueAsAttribute", "true"));
	int numberOfSubQuery = Integer.valueOf(JBIJetUtils.getRequiredPropertyValue(aStep,"NumberOfSubQueries"));
	String subQueryNamePropertyName = null;
	String subQuerySQLPropertyName = null;

        out.write(NL);         
        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":poller");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdatabaseType = \"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "DatabaseType"));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\tdriver = \"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "ConnectionDriver"));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\tURL = \"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"ConnectionURL"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\tuserName = \"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"ConnectionUser"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\tpassword = \"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"ConnectionPassword"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\tperiod = \"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"Period"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\tkey = \"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"Key"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\tinitialKeyValue = \"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"InitialKeyValue"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\tcommPointID=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep,"CommPointID"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
          if (JBIJetUtils.isValid(rowsForEachMessage)){
        out.write("\t\t\t\trowsInMessage =\"");  //$NON-NLS-1$        
        out.write(rowsForEachMessage);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
			}
			if (rowNameAsAttribute) { 
        out.write("\t\t\t\trowNameAsAttribute=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
			}
			if (colNameAsAttribute) { 
        out.write("\t\t\t\tcolumnNameAsAttribute=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
			}
			if (valueAsAttribute) { 
        out.write("\t\t\t\tvalueAsAttribute=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         
			}
        out.write(NL);         
        out.write("\t\t >");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t <rootStatement>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<bean class=\"org.spagic.smx.components.jdbc.StatementElement\">    ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\t\t\t<property name=\"name\" value=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "MainQueryName"));
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("          \t\t\t<property name=\"sql\" value=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "MainQuerySQL"));
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
		if (numberOfSubQuery > 0 ){

        out.write("\t\t\t\t\t<property name=\"subQueries\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t<list>");  //$NON-NLS-1$        
        out.write(NL);         
      	for (int i=0; i < numberOfSubQuery; i++){
				subQueryNamePropertyName ="SubQueries["+i+"].Name";
				subQuerySQLPropertyName = "SubQueries["+i+"].Sql";

        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<bean class=\"org.spagic.smx.components.jdbc.StatementElement\">    ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("     \t\t\t\t\t\t<property name=\"name\" value=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, subQueryNamePropertyName));
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("          \t\t\t\t\t<property name=\"sql\" value=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, subQuerySQLPropertyName));
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
			}
        out.write("\t\t\t\t\t</list>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t</property>");  //$NON-NLS-1$        
        out.write(NL);         
		} 
        out.write("\t\t\t\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</rootStatement>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":poller>");  //$NON-NLS-1$        
        out.write(NL);         
    }
}
