package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.jet.taglib.RuntimeTagElement;
import org.eclipse.jet.taglib.TagInfo;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBILightweight implements JET2Template {
    private static final String _jetns_ws = "org.eclipse.jet.workspaceTags"; //$NON-NLS-1$

    public _jet_JBILightweight() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$
    
    private static final TagInfo _td_ws_copyFile_65_2 = new TagInfo("ws:copyFile", //$NON-NLS-1$
            65, 2,
            new String[] {
                "src", //$NON-NLS-1$
                "srcContext", //$NON-NLS-1$
                "target", //$NON-NLS-1$
            },
            new String[] {
                "{$org.eclipse.jet.resource.project.name}/{$relativeFileNameToProject}", //$NON-NLS-1$
                "workspace", //$NON-NLS-1$
                "{$relativeFileNameToServiceUnit}", //$NON-NLS-1$
            } );

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	ServiceBinding binding = JBIJetUtils.getRightStepBinding(aStep);

        out.write(NL);         
        out.write("<sm:activationSpec componentName=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t   service=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t   ");  //$NON-NLS-1$        
        out.write( ( destinationStep != null ? "destinationService=\"" + SpagicUtils.getStepNameInProcess(aProcess, destinationStep) + "\">" : ">") );
        out.write(NL);         
        out.write(NL);         
        out.write("  \t  <sm:component>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t   <bean xmlns=\"http://xbean.org/schemas/spring/1.0\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t   \t\t class=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getLightweightClassForServiceBinding(binding,aStep));
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
 
	   	   List<IPropertyMap> configuredProperties = JBIJetUtils.getCodeGeneratorPropertyMap(binding);
	   	   String pSection = null;
	   	   for (IPropertyMap pMap : configuredProperties ) {
	   	   		pSection = pMap.eval(aStep);

        out.write("\t   \t   \t\t");  //$NON-NLS-1$        
        out.write(pSection);
        out.write(NL);         

	   	   	}

        out.write("\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       </bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      </sm:component>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    </sm:activationSpec>");  //$NON-NLS-1$        
        out.write(NL);         
 for (CopyResource copyResource : JBIJetUtils.getCodeGeneratorCopyResources(binding)) { 
    String fileNameRelativeToProject = JBIJetUtils.getRequiredPropertyValue(aStep, copyResource.getImProperty());
	context.setVariable("relativeFileNameToProject", fileNameRelativeToProject);
	context.setVariable("relativeFileNameToServiceUnit", JBIJetUtils.getRelativeFileName(fileNameRelativeToProject));

        out.write("\t");  //$NON-NLS-1$        
        RuntimeTagElement _jettag_ws_copyFile_65_2 = context.getTagFactory().createRuntimeTag(_jetns_ws, "copyFile", "ws:copyFile", _td_ws_copyFile_65_2); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_copyFile_65_2.setRuntimeParent(null);
        _jettag_ws_copyFile_65_2.setTagInfo(_td_ws_copyFile_65_2);
        _jettag_ws_copyFile_65_2.doStart(context, out);
        _jettag_ws_copyFile_65_2.doEnd();
        out.write(NL);         
 } 
    }
}
