package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardEIPPipeline implements JET2Template {

    public _jet_JBIStandardEIPPipeline() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	
	
	ServiceBinding binding = JBIJetUtils.getRightStepBinding(aStep);
	String transformerStepName = (String)aStep.getProperties().get("transformerStepName").getValue();

        out.write(NL);         
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":pipeline ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(" ");  //$NON-NLS-1$        
        out.write(NL);         
 	
	for (Transition t : aStep.getSourceTransitions()){
		destinationStep = t.getTarget();
		
		if (destinationStep.getName().equals(transformerStepName)){

        out.write("\t\t\t<eip:transformer>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t\t\t\t<eip:exchange-target service=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t\t</eip:transformer>");  //$NON-NLS-1$        
        out.write(NL);         

		}else{

        out.write("\t\t\t<eip:target>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t<eip:exchange-target service=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</eip:target>");  //$NON-NLS-1$        
        out.write(NL);         

		}

        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t  \t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":pipeline>");  //$NON-NLS-1$        
        out.write(NL);         
    }
}
