package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardFile implements JET2Template {

    public _jet_JBIStandardFile() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String endpointType = "poller";
	if (bindingName.equalsIgnoreCase("JBI-FileInputBindingComponent")){
   		endpointType = "poller";
   	}else if (bindingName.equalsIgnoreCase("JBI-FileOutputBindingComponent")) {
   		endpointType = "sender";
   	}
   	
   	
	String marshallerValue = "defaultFileMarshaler";
	
	String marshallerPropertyValue = JBIJetUtils.getOptionalPropertyValue(aStep,"Marshaller","DefaultFileMarshaller");

	if (marshallerPropertyValue.equalsIgnoreCase("BinaryFileMarshaller")){
		marshallerValue = "binaryFileMarshaler";
	}


if (endpointType.equalsIgnoreCase("poller")){

        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tfile=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "InputDirectory"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdeleteFile=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "FlagDeletePolledFile"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tperiod=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "PollingPeriod"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t >");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<file:marshaler>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
 if (marshallerValue.equalsIgnoreCase("binaryFileMarshaler")){
        out.write("\t\t\t\t\t\t<sm:contentType>binaryContentType</sm:contentType>");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t\t\t\t</sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</file:marshaler>\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
} else {
        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdirectory=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "OutputDirectory"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tappend=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "AppendContent"));
        out.write("\"\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t >");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<file:marshaler>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
 if (marshallerValue.equalsIgnoreCase("binaryFileMarshaler")){
        out.write("\t\t\t\t\t\t<sm:contentType>binaryContentType</sm:contentType>");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t\t\t\t</sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</file:marshaler>\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
}
    }
}
