package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.jet.taglib.RuntimeTagElement;
import org.eclipse.jet.taglib.TagInfo;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardHTTP implements JET2Template {
    private static final String _jetns_ws = "org.eclipse.jet.workspaceTags"; //$NON-NLS-1$

    public _jet_JBIStandardHTTP() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$
    
    private static final TagInfo _td_ws_copyFile_140_2 = new TagInfo("ws:copyFile", //$NON-NLS-1$
            140, 2,
            new String[] {
                "src", //$NON-NLS-1$
                "srcContext", //$NON-NLS-1$
                "target", //$NON-NLS-1$
            },
            new String[] {
                "{$org.eclipse.jet.resource.project.name}/{$relativeFileNameToProject}", //$NON-NLS-1$
                "workspace", //$NON-NLS-1$
                "{$relativeFileNameToServiceUnit}", //$NON-NLS-1$
            } );

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String role = "consumer";
   	if (bindingName.equalsIgnoreCase("JBI-HTTPOutputBindingComponent")){
   		role = "provider";
   	}
   	
   	// We Must understand if it's a pipeline transfomer
   	String isPipelineTransformer = JBIJetUtils.getOptionalPropertyValue(aStep, "IsTransformerPipeline", "false");
   	
	
		
   	String mep = null;
   	
   	if (bindingName.equalsIgnoreCase("JBI-HTTPInputBindingComponent")){
   		mep = JBIJetUtils.MEP_IN_ONLY;
   	} else {
   		mep = JBIJetUtils.MEP_IN_OUT;
   	}
   	
   	boolean flagTransformerPipeline = Boolean.valueOf(isPipelineTransformer);
	if (flagTransformerPipeline){
		role = "provider";
	}
   	
   	String locationURI = JBIJetUtils.getRequiredPropertyValue(aStep, "Uri");
   	String soap = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagIsSoap", "true");
   	String soapVersion = JBIJetUtils.getOptionalPropertyValue(aStep, "SoapAction", "");
   	String soapAction = JBIJetUtils.getOptionalPropertyValue(aStep, "SoapVersion", "");
   	String wsdlFile = JBIJetUtils.getOptionalPropertyValue(aStep, "WsdlFile", null);
   	
   	String isSslEnabledString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagIsSsl", "false");
	Boolean isSslEnabled = Boolean.valueOf(isSslEnabledString);
	
	
	// WSDL Is not specify as property 
	if (wsdlFile == null) {
		String projectName = (String)context.getVariable("org.eclipse.jet.resource.project.name");
		wsdlFile = "WsdlFiles/"+SpagicUtils.getStepLocalNamePart(aProcess, aStep) + ".wsdl";
		boolean existWsdlFile = JBIJetUtils.existFileInProject(projectName, wsdlFile);
		if (!existWsdlFile){
			System.out.println(" wsdlFile [" +wsdlFile +"] do not exist ");
			wsdlFile = null;
		}
	}
	

        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":endpoint");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tdefaultMep=\"");  //$NON-NLS-1$        
        out.write(mep);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
      if ("provider".equals(role)) {
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}else{
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}
        out.write("\t\t\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\trole=\"");  //$NON-NLS-1$        
        out.write(role);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tlocationURI=\"");  //$NON-NLS-1$        
        out.write(locationURI);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tsoap=\"");  //$NON-NLS-1$        
        out.write(soap);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tsoapVersion=\"");  //$NON-NLS-1$        
        out.write(soapVersion);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tsoapAction=\"");  //$NON-NLS-1$        
        out.write(soapAction);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         

					if (wsdlFile != null){
						String wsdlresourceString = "classpath:"+JBIJetUtils.getRelativeFileName(wsdlFile);
					   	

        out.write("\t\t\t\t\t   wsdlResource=\"");  //$NON-NLS-1$        
        out.write(wsdlresourceString);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t   ");  //$NON-NLS-1$        
        out.write(NL);         
 					}
        out.write("\t\t\t\t\t>");  //$NON-NLS-1$        
        out.write(NL);         
 if (isSslEnabled) { 
						String keyStoreR = "classpath:"+ JBIJetUtils.getRequiredPropertyValue(aStep, "KeyStore");
						String keyStorePass = JBIJetUtils.getRequiredPropertyValue(aStep, "KeyStorePassword");
						String keyStoreType = JBIJetUtils.getOptionalPropertyValue(aStep, "KeyStoreType", "JKS");
						String trustStoreR = "classpath:"+ JBIJetUtils.getRequiredPropertyValue(aStep, "TrustStore");
						String trustStorePass = JBIJetUtils.getRequiredPropertyValue(aStep, "TrustStorePassword");
						String trustStoreType = JBIJetUtils.getOptionalPropertyValue(aStep, "TrustStoreType", "JKS");
					
        out.write("\t\t\t\t\t\t<http:ssl>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t<http:sslParameters ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t  keyStore=\"");  //$NON-NLS-1$        
        out.write(keyStoreR);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t  keyStorePassword=\"");  //$NON-NLS-1$        
        out.write(keyStorePass);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t  keyStoreType=\"");  //$NON-NLS-1$        
        out.write(keyStoreType);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
 if (trustStoreR != null) { 
        out.write("    \t\t\t\t\t\t\t trustStore=\"");  //$NON-NLS-1$        
        out.write(trustStoreR);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t trustStoreType=\"");  //$NON-NLS-1$        
        out.write(trustStoreType);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
 } 
 if (trustStorePass != null) { 
        out.write("    \t\t\t\t\t\t\t trustStorePassword=\"");  //$NON-NLS-1$        
        out.write(trustStorePass);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
 } 
 if (role.equalsIgnoreCase("consumer")) { 
        out.write("    \t\t\t\t\t\t\t\twantClientAuth=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FlagWantClientAuthentication","false"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("    \t\t\t\t\t\t\t\tneedClientAuth=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FlagNeedClientAuthentication","false"));
        out.write("\" ");  //$NON-NLS-1$        
        out.write(NL);         
 } 
        out.write("    \t\t\t\t\t\t/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t\t\t\t\t</http:ssl>");  //$NON-NLS-1$        
        out.write(NL);         
 } 
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":endpoint>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
	if (wsdlFile != null) {
	context.setVariable("relativeFileNameToProject", wsdlFile);
	context.setVariable("relativeFileNameToServiceUnit", JBIJetUtils.getRelativeFileName(wsdlFile));
	

        out.write("\t");  //$NON-NLS-1$        
        RuntimeTagElement _jettag_ws_copyFile_140_2 = context.getTagFactory().createRuntimeTag(_jetns_ws, "copyFile", "ws:copyFile", _td_ws_copyFile_140_2); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_copyFile_140_2.setRuntimeParent(null);
        _jettag_ws_copyFile_140_2.setTagInfo(_td_ws_copyFile_140_2);
        _jettag_ws_copyFile_140_2.doStart(context, out);
        _jettag_ws_copyFile_140_2.doEnd();
        out.write(NL);         
 } 
    }
}
