package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardJMS implements JET2Template {

    public _jet_JBIStandardJMS() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String role = "consumer";
   	if (bindingName.equalsIgnoreCase("JBI-JMSOutputBindingComponent")){
   		role = "provider";
   	}
   	
   	// We Must understand if it's a pipeline transfomer
   	String isPipelineTransformer = JBIJetUtils.getOptionalPropertyValue(aStep, "IsTransformerPipeline", "false");
   	
   	String mep = null;
   	mep = JBIJetUtils.MEP_IN_ONLY;
   	if (bindingName.equalsIgnoreCase("JBI-JMSInputOutputBindingComponent")){
   		mep = JBIJetUtils.MEP_IN_OUT;
   	} 
   	
   	boolean flagTransformerPipeline = Boolean.valueOf(isPipelineTransformer);
	if (flagTransformerPipeline){
		role = "provider";
	}
   	
   
   	String soap = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagIsSoap", "false");
   	String soapVersion = JBIJetUtils.getOptionalPropertyValue(aStep, "SoapVersion", "1.2");
   	
   	boolean flagIsSoap = Boolean.valueOf(soap);
   	
   	String useJndiContextFromJbiContainer = JBIJetUtils.getRequiredPropertyValue(aStep, "UseJndiContextFromJbiContainer"); 
	boolean flagUseJndiContextFromJbiContainer = Boolean.valueOf(useJndiContextFromJbiContainer);
	
	String useJndiDetination = JBIJetUtils.getRequiredPropertyValue(aStep, "FlagUseJndiDestination"); 
	boolean flagUseJndiDetination = Boolean.valueOf(useJndiDetination);

        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":endpoint");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tdefaultMep=\"");  //$NON-NLS-1$        
        out.write(mep);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
      if ("consumer".equals(role)) {
        out.write("\t\t\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\ttargetEndpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\trole=\"");  //$NON-NLS-1$        
        out.write(role);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
      if (flagIsSoap) {
        out.write("\t\t\t\t\tsoap=\"");  //$NON-NLS-1$        
        out.write(soap);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\tsoapVersion=\"");  //$NON-NLS-1$        
        out.write(soapVersion);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}
        out.write(NL);         
		if (!flagUseJndiContextFromJbiContainer) {
        out.write("\t\t\tinitialContextFactory=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "InitialContextFactory"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tjndiProviderURL=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "JndiProviderUrl"));
        out.write(NL);         
		}
        out.write(NL);         
      if (flagUseJndiDetination) {
        out.write("\t\t\tjndiDestinationName=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "JndiDestinationName"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}else{
        out.write("\t\t\tjmsProviderDestinationName=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "JmsProviderDestinationName"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t\tdestinationStyle=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "JmsDestinationType"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}
        out.write(NL);         
      if ("consumer".equals(role)) {
			boolean isUseMsgIdInResponse=Boolean.valueOf(JBIJetUtils.getOptionalPropertyValue(aStep, "UseJmsMessageId", "false"));
			if (isUseMsgIdInResponse){	

        out.write("\t\t\t\tuseMsgIdInResponse=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         

			}		
		}

        out.write(NL);         
      if ("provider".equals(role)) {
			boolean isNeedJavaIdentifiers =Boolean.valueOf(JBIJetUtils.getOptionalPropertyValue(aStep, "NeedJavaIdentifiers", "false"));
			if (isNeedJavaIdentifiers){	

        out.write("\t\t\t\tneedJavaIdentifiers=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         

			}		
		}

        out.write("\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":endpoint>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
    }
}
