package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardTCP implements JET2Template {

    public _jet_JBIStandardTCP() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	
   	
   	// We Must understand if it's a pipeline transfomer
   	String isPipelineTransformer = JBIJetUtils.getOptionalPropertyValue(aStep, "IsTransformerPipeline", "false");
   	
	
		
   	String mep = JBIJetUtils.MEP_IN_OUT;
   	
   	
   	String role = "consumer";
   	boolean flagTransformerPipeline = Boolean.valueOf(isPipelineTransformer);
	if (flagTransformerPipeline){
		role = "provider";
	}


        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(role);
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
      if ("consumer".equals(role)) {
        out.write("\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":config>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":tcpBCConfig");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("\t\t\tpointName=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tpointType=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "ConnectionPointType"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tpointMode=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "ConnectionPointMode"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\toutNmEnvelope=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "NormalizedMessageOutputEnvelope"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tinNmEnvelope=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "NormalizedMessageInputEnvelope"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tbase64encode=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "FlagBase64EncodeMessage"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tbase64decode=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "FlagBase64DecodeMessage"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdefaultMep=\"");  //$NON-NLS-1$        
        out.write(mep);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tincomingWrapper=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "IncomingWrapper"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tincomingHeader=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "IncomingHeader"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tincomingTrailer=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "IncomingTrailer"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tstripWrapping=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "StripWrapping"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\toutgoingWrapper=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "OutgoingWrapper"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\toutgoingHeader=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "OutgoingHeader"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\toutgoingTrailer=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "OutgoingTrailer"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tlogConnections=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "LogConnections"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tlogData=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "LogData"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tlogDataAsHex=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "LogDataInExadecimal"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tconnectionLogFileName=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "LogFileName", ""));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\textraInformation=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "LogExtraInfo"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tuseSSL=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "FlagIsSslEnabled"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\tuseSSLClientMode=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FlagUseSslClientAuthentication", "false"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tkeyStoreFileName=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "KeyStore", ""));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t\t\tkeyStorePassword=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "KeyStorePassword", ""));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t\t\ttrustStoreFileName=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "TrustStore", ""));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t\t\ttrustStorePassword=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "TrustStorePassword", ""));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
  if (role.equalsIgnoreCase("consumer")){
        out.write("       \t\t\tconnNumber=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "ConnectionNumber"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\t\tlocalPort=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "LocalPort"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\t\tlocalAddress=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "LocalAddress"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
} 
  if (role.equalsIgnoreCase("provider")){
        out.write("       \t\t\tconnectionMode=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "ConnectionMode"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\t\tremotePort=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "RemotePort"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\t\tremoteHost=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "RemoteHost"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t\t\tresponseTimeout=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "ResponseTimeOut"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\tretryCount=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "RetryCount"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\tfailAction=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "FailAction"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\tretryNumber=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "RetryNumber"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\tretryType=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "RetryType"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\tretryDelay=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "RetryDelay"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\ttcpOutInReceiverClassName=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "TcpOutInReceiverClassName"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("       \t");  //$NON-NLS-1$        
}
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":tcpBCConfig>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":config>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(role);
        out.write(">");  //$NON-NLS-1$        
    }
}
