package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_RoutingRules implements JET2Template {

    public _jet_RoutingRules() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        out.write(NL);         
        out.write("package org.apache.servicemix.drools");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("import org.apache.servicemix.drools.model.Exchange;");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("global org.apache.servicemix.drools.model.JbiHelper jbi;");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
	int numberRule = 0;
	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step sourceStep = (Step)context.getVariable("step");

		List<Transition> transitions  = sourceStep.getSourceTransitions();
		
		Step destinationStep = null;
		Condition condition = null;
		for ( Transition t : transitions){
			if (!(t instanceof TransitionUnderCondition)) {
				throw new RuntimeException(" Transition outcoming from router must be conditioned");
			}
				destinationStep = t.getTarget();
				condition = ((TransitionUnderCondition)t).getCondition();

        out.write("rule \"RuleNum");  //$NON-NLS-1$        
        out.write( ++numberRule );
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\twhen");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\tme : Exchange( status == Exchange.ACTIVE, in : in != null )");  //$NON-NLS-1$        
        out.write(NL);         
 if (condition instanceof ExpressionCondition) { 
		String xPathExpression = ((ExpressionCondition)condition).getExpression();

        out.write("\t\teval( in.xpath(\"");  //$NON-NLS-1$        
        out.write(xPathExpression);
        out.write("\") )");  //$NON-NLS-1$        
        out.write(NL);         
 } else { 
		String propName = ((PropertyCondition)condition).getPropertyName();
		String propValue = ((PropertyCondition)condition).getPropertyValue();
		String operator = ((PropertyCondition)condition).getOperator();

		if ( operator.equals("=") ) { 
        out.write("\t\t\teval( \"");  //$NON-NLS-1$        
        out.write( propValue );
        out.write("\".equals(in.getProperty(\"");  //$NON-NLS-1$        
        out.write( propName );
        out.write("\")) )");  //$NON-NLS-1$        
        out.write(NL);         
 } else if ( operator.equals("!=") || operator.equals("<>") ) { 
        out.write("\t\t\teval( in.getProperty(\"");  //$NON-NLS-1$        
        out.write( propName );
        out.write("\") != null &&");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t!\"");  //$NON-NLS-1$        
        out.write( propValue );
        out.write("\".equals(in.getProperty(\"");  //$NON-NLS-1$        
        out.write( propName );
        out.write("\")) )");  //$NON-NLS-1$        
        out.write(NL);         
 } 
 }
        out.write("\tthen");  //$NON-NLS-1$        
        out.write(NL);         

		  String routingDestination = "service:" + SpagicUtils.getNameSpaceForProcess(aProcess) + ":" + SpagicUtils.getStepLocalNamePart(aProcess,destinationStep);

        out.write("\t\t  jbi.route(\"");  //$NON-NLS-1$        
        out.write(routingDestination);
        out.write("\");");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\tend");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
    }
}
