package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_jbixml implements JET2Template {

    public _jet_jbixml() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)(context.getVariable("process"));
	Map<String, List<String>> processServiceUnitsMap = (Map<String, List<String>>)context.getVariable("processServiceUnitsMap");
	Set<String> sus = processServiceUnitsMap.keySet();

        out.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("<jbi xmlns=\"http://java.sun.com/xml/ns/jbi\" version=\"1.0\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t<service-assembly>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<identification>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<name>");  //$NON-NLS-1$        
        out.write(aProcess.getName()+ "_v_" + SpagicUtils.getProcessVersion(aProcess));
        out.write("</name>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<description>Generated by Spagic Studio STP-JBI-Generator</description>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</identification>");  //$NON-NLS-1$        
        out.write(NL);         
 		
	String suName = null;
	String suDescription = null;
	String suArtifact = null;
	String suComponentName = null;
	for ( String su : sus ){ 
		suName = aProcess.getName()+ "_v_" + SpagicUtils.getProcessVersion(aProcess) + "-" + JBIJetUtils.getServiceUnitBriefName(su);
		suDescription = "Description for " + suName;
		suArtifact = suName + ".zip";
		suComponentName = JBIJetUtils.getComponentNameForServiceUnit(su);

        out.write("\t\t<service-unit>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<identification>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<name>");  //$NON-NLS-1$        
        out.write(suName);
        out.write("</name>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<description>");  //$NON-NLS-1$        
        out.write(suDescription);
        out.write("</description>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</identification>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<target>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<artifacts-zip>");  //$NON-NLS-1$        
        out.write(suArtifact);
        out.write("</artifacts-zip>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<component-name>");  //$NON-NLS-1$        
        out.write(suComponentName);
        out.write("</component-name>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</target>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</service-unit>");  //$NON-NLS-1$        
        out.write(NL);         
} // end suLoop 
        out.write("\t</service-assembly>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("</jbi>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
    }
}
