/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.im.out.jbi.smx.actions;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.jet.JET2Platform;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.stp.im.ImPackage;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.spagic.im.out.jbi.smx.utils.JBIJetUtils;
import org.spagic.im.out.jbi.smx.utils.ZipUtils;



public class ServiceMixAssemblyGeneratorAction implements IObjectActionDelegate {
	
	private IFile imFile = null;
	
	public IFile getImFile() {
		return imFile;
	}

	public void setImFile(IFile imFile) {
		this.imFile = imFile;
	}
	
	/**
	 * Constructor for Action1.
	 */
	public ServiceMixAssemblyGeneratorAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		
		// Read the bpmn emf model
		ResourceSet resourceSetIM = new ResourceSetImpl();
		URI uri = URI.createFileURI(imFile.getFullPath().toString());
		
		// Force Package Registration
		ImPackage imPackage = ImPackage.eINSTANCE;
		
		// Load On Demand = true 
		Resource resourceIM = resourceSetIM.getResource(uri, true);
		
		Map<String, String> variables = new HashMap<String, String>();

		variables.put("org.eclipse.jet.resource.project.name",imFile.getProject().getName());

		System.out.println("About to call common generate method in JET project");
		IStatus status = JET2Platform.runTransformOnObject("org.spagic.im.out.jbi.smx", 
				resourceIM, variables,new NullProgressMonitor() );

		
		for (String aFolder : JBIJetUtils.getFolders()){
			IFolder iFolder = imFile.getProject().getFolder(aFolder);
			ZipUtils.getDefault().zipFolderAndSubFolder(iFolder);
		}
		
		MessageDialog.openInformation(new Shell(), "Spagic", "Service Assembly Code Generation Completed");
	}

	public final void selectionChanged(final IAction action,
			final ISelection selection) {
		
		setImFile((IFile) ((StructuredSelection) selection)
				.getFirstElement());
	}

			
}
