/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.im.out.jbi.smx.utils;

import org.eclipse.stp.im.Property;
import org.eclipse.stp.im.Step;

public abstract class AbstractPropertyMap implements IPropertyMap {

	protected String imName = null;
	protected String runtimeName = null;
	protected boolean required = false;
	protected boolean produceConfiguration = true;
	protected IDecorator decorator = null;
	protected String condition = null;
	
	public AbstractPropertyMap() {
		super();
		
	}

	public String getImName() {
		return imName;
	}

	public void setImName(String imName) {
		this.imName = imName;
	}

	public String getRuntimeName() {
		return runtimeName;
	}

	public void setRuntimeName(String runtimeName) {
		this.runtimeName = runtimeName;
	}

	public boolean isRequired() {
		return required;
	}

	public void setRequired(boolean isRequired) {
		this.required = isRequired;
	}

	public boolean isProduceConfiguration() {
		return produceConfiguration;
	}

	public void setProduceConfiguration(boolean produceConfiguration) {
		this.produceConfiguration = produceConfiguration;
	}

	public IDecorator getDecorator() {
		return decorator;
	}

	public void setDecorator(IDecorator decorator) {
		this.decorator = decorator;
	}
	
	public abstract String eval(Step s);

	public boolean evaluateGenerationCondition(Step aStep){
		
		if (condition.startsWith("if-is-true")){
			String propName = condition.substring(condition.indexOf("(") + 1, condition.indexOf(")"));
			Property aProperty = aStep.getProperties().get(propName);
			String value = aProperty != null ? aProperty.getValue().toString() : null;
			return (value != null && Boolean.valueOf(value));
		}
		if (condition.startsWith("if-is-false")){
				String propName = condition.substring(condition.indexOf("(") + 1, condition.indexOf(")"));
				
				Property aProperty = aStep.getProperties().get(propName);
				String value = aProperty != null ? aProperty.getValue().toString() : null;
				return (value != null && !Boolean.valueOf(value));
		}
		if (condition.startsWith("if-has-value")){
			String propName = condition.substring(condition.indexOf("(") + 1, condition.indexOf(","));
			String valueToEnableVisibility=condition.substring(condition.indexOf(",") + 1, condition.indexOf(")"));
			Property aProperty = aStep.getProperties().get(propName);
			String value = aProperty != null ? aProperty.getValue().toString() : null;
			return value.equalsIgnoreCase(valueToEnableVisibility);
		}
		return false;
	}

	public String getCondition() {
		return condition;
	}

	public void setCondition(String condition) {
		this.condition = condition;
	}

	public boolean isUnderCondition() {
		if ((condition == null) || (condition.trim().length() == 0))
			return false;
		else{
			return true;
		}
	}


}