/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.im.out.jbi.smx.utils;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.stp.im.Step;


public class BeanPropertyMap extends AbstractPropertyMap {
	
	protected List<IPropertyMap> childrenProperties = null;

	protected String beanClassName = null;
	public BeanPropertyMap(String imName, String runtimeName, boolean required) {
		super();
		this.imName = imName;
		this.runtimeName = runtimeName;
		this.required = required;
		childrenProperties = new ArrayList<IPropertyMap>();
	}

	
	public String eval(Step s){
		StringBuffer sb = new StringBuffer();
		sb.append("<property name=\""+runtimeName+"\">"); 
		sb.append("<bean class=\""+beanClassName+"\">\n");
		for (IPropertyMap propMap : childrenProperties){
			sb.append(propMap.eval(s));
		}
		sb.append("</bean>\n");
		sb.append("</property>");			
		return sb.toString();
	}
	

	public String getBeanClassName() {
		return beanClassName;
	}
	public void setBeanClassName(String beanClassName) {
		this.beanClassName = beanClassName;
	}
	public List<IPropertyMap> getChildrenProperties() {
		return childrenProperties;
	}

	public void setChildrenProperties(List<IPropertyMap> childrenProperties) {
		this.childrenProperties = childrenProperties;
	}
	
	
	
	
}
