/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.im.out.jbi.smx.utils;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.stp.im.Property;
import org.eclipse.stp.im.Step;
import org.eclipse.stp.im.runtime.IProperty;
import org.jaxen.function.IdFunction;


public class ListPropertyMap extends MultiValuePropertyMap {
	
	public ListPropertyMap(String imName, String runtimeName, boolean required) {
		super();
		this.imName = imName;
		this.runtimeName = runtimeName;
		this.required = required;
		this.valueBeanClass = String.class.getName();
	}
	/** (non-Javadoc)
	 * @see org.spagic.im.out.jbi.smx.utils.IPropertyMap#eval(org.eclipse.stp.im.Step)
	 */
	public String eval(Step s){
		
		StringBuffer sb = new StringBuffer();
		sb.append("<property name=\""+runtimeName+"\">"); 
		sb.append("<list>\n");
		Map<String, Map<String, String>> mapValueToGenerate = getMapValue(s);
		Map<String,String> detail = null;
		for ( String key : mapValueToGenerate.keySet()){
			detail = mapValueToGenerate.get(key);
			if (valueBeanClass.equalsIgnoreCase(String.class.getName())){
				sb.append("<bean class=\""+valueBeanClass+"\">\n");
				sb.append("   <constructor-arg value=\""+detail.get(beanMappings.get(0).getImName())+"\" />\n");
				sb.append("</bean>\n");
			}else{
				sb.append("<bean class=\""+valueBeanClass+"\">\n");
				for (SimplePropertyMap simpleProperty : beanMappings){
					sb.append(simpleProperty.evalOnMap(detail));
				}
				sb.append("</bean>\n");
			}
		}
		
		sb.append("</list>\n");
		sb.append("</property>\n");
		return sb.toString();
	}
	
	
	
	
	
	
	
	
}
