/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.im.out.jbi.smx.utils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.stp.im.Property;
import org.eclipse.stp.im.Step;

public abstract class MultiValuePropertyMap extends AbstractPropertyMap {

	protected String valueBeanClass = null;
	public List<SimplePropertyMap> beanMappings = null;

	public MultiValuePropertyMap() {
		super();
		valueBeanClass = String.class.getName();
		beanMappings = new ArrayList<SimplePropertyMap>();
	}

	public Map<String, Map<String, String>> getMapValue(Step aStep) {
		Map<String, Map<String, String>> mapProperties = new HashMap<String, Map<String,String>>();
		
		String idxMapPropertyString = null;
		Map<String, String> entryValues = null;
		String displayName = null;
		Property inStepProperty = null;
		for (String key : aStep.getProperties().keySet()){
	
			if (key.indexOf("[") <= 0) // This property is not related to a map property
				continue;
			if (!key.startsWith(imName)) // This property is related to another map
				continue;
			
	
			inStepProperty = aStep.getProperties().get(key);
			
			idxMapPropertyString = key.substring(key.indexOf("[") +1, key.indexOf("]"));
			displayName = key.substring(key.indexOf("]") + 2);
			entryValues = mapProperties.get(idxMapPropertyString);
			if (entryValues == null)
				entryValues = new HashMap<String, String>();
			entryValues.put(displayName, (String)inStepProperty.getValue());
			mapProperties.put(idxMapPropertyString, entryValues);
		}
		return mapProperties;
	}

	public List<SimplePropertyMap> getBeanMappingProperty() {
		return beanMappings;
	}

	public void setBeanMappingProperty(List<SimplePropertyMap> beanMappingProperty) {
		this.beanMappings = beanMappingProperty;
	}

	public String getValueBeanClass() {
		return valueBeanClass;
	}

	public void setValueBeanClass(String valueBeanClass) {
		this.valueBeanClass = valueBeanClass;
	}

}