/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.im.out.metadb.processor;

import org.eclipse.stp.im.StpIntermediateModel;

/**
 * This interface has to be implemented by specific binding pre-processor
 * that has the meaning of changing the process (if necessary) before
 * saving it on the database.
 *
 */
public interface IProcessor {
	
	/**
	 * Change the Intermediate Model Process according to some specific binding
	 * rules.
	 * @param process Original IM process
	 * @param stpIntermediateModel TODO
	 * @return Modified IM process
	 */
	org.eclipse.stp.im.Process preProcess(org.eclipse.stp.im.Process process, StpIntermediateModel stpIntermediateModel);
	
	/**
	 * @return The name of the processor
	 */
	String getName();
	
	/**
	 * @return The binding managed by the processor, i.e. runtime.bpel or runtime.jbi.smx
	 */
	String getRuntime();
	
	/**
	 * @return The tecnology managed by the processor, i.e. JBI or BPEL
	 */
	String getTechnology();
	
}
