/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.actions;

import java.util.Collections;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.stp.bpmn.BpmnDiagram;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.spagic.ui.SpagicUIActivator;
import org.spagic.ui.dialog.ConfigureIterDialog;
import org.spagic.utils.SpagicLogger;

public class ConfigureIterAction implements IObjectActionDelegate {

	private IFile bpmnFile = null;

	/**
	 * Constructor for Action1.
	 */
	public ConfigureIterAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		Shell shell = new Shell();
	
		
		try{
			System.out.println(" Configuring Iter on " + this.bpmnFile.getName());
			ResourceSet resourceSetBpmn = new ResourceSetImpl();
			URI uri = URI.createFileURI(bpmnFile.getFullPath().toString());
		
			Resource resourceBpmn = resourceSetBpmn.getResource(uri, true);	
			BpmnDiagram bpmnDiagram= (BpmnDiagram)resourceBpmn.getContents().get(0);
			
			// Avoid nullpointer exception ind dialog if diagram name is not there
			String fileName = this.bpmnFile.getName();
			String diagramName = bpmnDiagram.getName();
			String iterCandidateName = fileName.substring(0, fileName.indexOf("."));
			if (diagramName == null)
				bpmnDiagram.setName(iterCandidateName);
			else if ( diagramName.trim().length() == 0)
				bpmnDiagram.setName(iterCandidateName);
			
			ConfigureIterDialog aConfigureIterTypeDialog = new ConfigureIterDialog(shell,bpmnDiagram);
			aConfigureIterTypeDialog.open();
			resourceBpmn.save(Collections.EMPTY_MAP);
			
		}catch (Exception e) {
			e.printStackTrace();
			SpagicLogger.error(SpagicUIActivator.PLUGIN_ID, e.getMessage(), e);
		}
		
	}

	public final void selectionChanged(final IAction action,
			final ISelection selection) {	
		setBpmnFile((IFile) ((StructuredSelection) selection)
				.getFirstElement());
	}
	
	public IFile getBpmnFile() {
	
		return bpmnFile;
	
	}

	public void setBpmnFile(IFile bpmnFile) {
		this.bpmnFile = bpmnFile;
	}
	

	
	
	
	
	
}
