/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.combovaluesprovider;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.eclipse.stp.im.runtime.IComboProviderValues;
import org.eclipse.stp.im.runtime.comboproviders.ComboEntries;
import org.spagic.ui.SpagicUIActivator;

public  abstract class SpagicHL7TransformationAbstractComboProviderValues implements IComboProviderValues {
	
	public abstract String getTransformationType();
	
	public ComboEntries getComboEntries() {
		ComboEntries ce = new ComboEntries();
		List<String> tmpLabels = new ArrayList<String>();
		List<String> tmpValues = new ArrayList<String>();
		
		Map<String, String> hl7Transformations = SpagicUIActivator.getHL7Map(getTransformationType());
		for (String name : hl7Transformations.keySet()){
			tmpLabels.add(name);
			tmpValues.add(hl7Transformations.get(name));
		}
		
		String[] labels = new String[tmpLabels.size()];
		String[] values = new String[tmpValues.size()];
		ce.setLabels(tmpLabels.toArray(labels));
		ce.setValues(tmpValues.toArray(values));
		return ce;
	}

}
