/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.dialog;

import org.spagic.metadb.dbutils.AuditDBUtils;
import org.spagic.metadb.model.Catalog;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;
import org.hibernate.Session;
import org.spagic.ui.SpagicUIActivator;
import org.spagic.ui.helpers.IMetaDBCommand;
import org.spagic.ui.helpers.MetaDBHelper;
import org.spagic.utils.SpagicLogger;

public class NewCatalogObservableAttributeDialog extends SpagicTitleAreaDialog {


	

    private Composite aComposite = null;
    private CLabel catalogNameLabel = null;
    private Text catalogNameTextField = null;
    
    private CLabel catalogVisibleLabel = null;
    private Button catalogVisibleCheckBox = null;
    private CLabel catalogMandatoryLabel = null;
    private Button catalogMandatoryCheckBox = null;
    
    
    
    public boolean status = false;
    
    
	public NewCatalogObservableAttributeDialog(Shell parentShell) {
		super(parentShell);

	}
	
	
				

	/**
	   * @see org.eclipse.jface.window.Window#create() We complete the dialog with
	   *      a title and a message
	   */
	  public void create() {
		super.create();
	    
	    setTitle("New Catalog");
	    setMessage("Create a New Catalog");
	    
	  }

	 
	  

	@Override
	protected Control createContents(Composite parent) {
		Control ctrl = super.createContents(parent);
		return ctrl;
	}

	protected Control createDialogArea(Composite parent) {
		
        
  
		
		aComposite = new Composite(parent, SWT.NONE);
		final GridLayout layout = new GridLayout();
    	layout.marginWidth = 15;
    	layout.marginHeight = 10;
    	layout.numColumns = 5;
    	aComposite.setLayout(layout);
    	aComposite.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
    	
    	
    	GridData data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	
    	
    	
    	
    	// Riga 2
    	catalogNameLabel = new CLabel(aComposite, SWT.RIGHT);
    	catalogNameLabel.setText(" Catalog Name ");
    	catalogNameTextField = new Text(aComposite, SWT.BORDER | SWT.FLAT );
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	catalogNameTextField.setLayoutData(data);
    	
    	
    	catalogVisibleLabel = new CLabel(aComposite, SWT.RIGHT);
    	catalogVisibleLabel.setText(" Is Visible ");
    	catalogVisibleCheckBox = new Button(aComposite, SWT.CHECK );
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	catalogVisibleCheckBox.setLayoutData(data);
    		

    	catalogMandatoryLabel = new CLabel(aComposite, SWT.RIGHT);
    	catalogMandatoryLabel.setText(" Is Mandatory ");
    	catalogMandatoryCheckBox = new Button(aComposite, SWT.CHECK );
    	data = new GridData(GridData.FILL_HORIZONTAL);
    	data.widthHint = 200;
    	data.horizontalSpan = 4;
    	catalogMandatoryCheckBox.setLayoutData(data);
    		
        return parent; 
	
	}
	
	protected void okPressed() {
		try{
			final NewCatalogObservableAttributeDialog theDialog = this;
			
			this.status = (Boolean)MetaDBHelper.doExecuteTx(new IMetaDBCommand(){
				public Object execute(Session aSession) throws Throwable {
					if (AuditDBUtils.getCatalogByName(aSession, catalogNameTextField.getText()) != null)
						return false;
					Catalog newCatalog = new Catalog();
					newCatalog.setName(catalogNameTextField.getText());
					newCatalog.setVisible(theDialog.catalogVisibleCheckBox.getSelection());
					newCatalog.setMandatory(theDialog.catalogMandatoryCheckBox.getSelection());
					AuditDBUtils.storeCatalog(aSession, newCatalog);
					return true;
				}});
			if (this.status){
				close();
			}else{
				MessageDialog.openWarning(PlatformUI.getWorkbench()
						.getActiveWorkbenchWindow().getShell(), "Spagic",
						"A Catalog with this name already exist !!!");
			}
			
		} catch (Exception e) {
			SpagicLogger.error(SpagicUIActivator.PLUGIN_ID, e.getMessage(), e);
			MessageDialog.openError(PlatformUI.getWorkbench()
					.getActiveWorkbenchWindow().getShell(), "Spagic",
					"An error is occurred [" + e.getMessage() + "]");
			this.status = false;
			return;
		}
	}
	
	@Override
	protected void buttonPressed(int buttonId) {
		super.buttonPressed(buttonId);
	}




	public boolean isStatus() {
		return status;
	}




	public void setStatus(boolean status) {
		this.status = status;
	}




	
	
}
