/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.dnd;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.stp.bpmn.dnd.IDnDHandler;
import org.spagic.ui.view.ObservableAttributeTreeElement;

public class RelevantDataTreeElementAdapterFactory implements IAdapterFactory {     

    @SuppressWarnings("unchecked")
 	public Object getAdapter(Object adaptableObject, Class adapterType) {
    	if (adapterType.equals(IDnDHandler.class)) {
 			if (adaptableObject instanceof ObservableAttributeTreeElement) {
 			
 				return new org.spagic.ui.dnd.handler.ObservableAttributeDndHandler((ObservableAttributeTreeElement)adaptableObject);
 			}
 		}
 		return null;
 	}

 	
 	/**
      * Returns the collection of adapter types handled by this
      * factory.
      * <p>
      * This method is generally used by an adapter manager
      * to discover which adapter types are supported, in advance
      * of dispatching any actual <code>getAdapter</code> requests.
      * </p>
      *
      * @return the collection of adapter types
      */
 	@SuppressWarnings("unchecked")
 	public Class[] getAdapterList() {
 		return new Class[] {IDnDHandler.class};
 	}
}
