/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.dnd.decorator;


import java.text.MessageFormat;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorTarget.Direction;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.stp.bpmn.dnd.IEAnnotationDecorator;
import org.eclipse.stp.im.constants.ImConstants;
import org.spagic.ui.SpagicUIActivator;

public class ObservableAttributeDecorator implements IEAnnotationDecorator {

	public ImageDescriptor getImageDescriptor(EditPart part,
			EModelElement element, EAnnotation annotation) {
		ImageDescriptor desc = SpagicUIActivator.getImageDescriptor("icons/ico_relevant_data.png");
		return desc;
	}

	public String getAssociatedAnnotationSource() {
		return ImConstants.IM_OBSERVABLE_ATTRIBUTE;
		
	}

	public Direction getDirection(EditPart part, EModelElement element,
			EAnnotation annotation) {
		return Direction.CENTER;
	}

	

	public IFigure getToolTip(EditPart part, EModelElement element, EAnnotation annotation) {
		
		StringBuffer bufferForDraw2dLabel = new StringBuffer();
		if (element.getEAnnotation(ImConstants.IM_OBSERVABLE_ATTRIBUTE) != null){
			EMap<String, String> details = element.getEAnnotation(ImConstants.IM_OBSERVABLE_ATTRIBUTE).getDetails();
			bufferForDraw2dLabel.append("Relevant Data Set \n");
			Integer size = Integer.valueOf(element.getEAnnotation(ImConstants.IM_OBSERVABLE_ATTRIBUTE).getDetails().get(ImConstants.IM_OBSERVABLE_ATTRIBUTE_LIST_SIZE));
			String attName = null;
			String attExpression = null;
			for ( int i = 1; i <= size; i++){
				attName = details.get(MessageFormat.format(ImConstants.IM_OBSERVABLE_ATTRIBUTE_NAME, i));
				attExpression = details.get(MessageFormat.format(ImConstants.IM_OBSERVABLE_ATTRIBUTE_RULE_EXPRESSION, i));
				
				bufferForDraw2dLabel.append(" " + attName + " <- "+ attExpression + "\n");
			}
		}else{
			bufferForDraw2dLabel.append(" No Relevant Data Set Configured ");
		}
        return new org.eclipse.draw2d.Label(bufferForDraw2dLabel.toString());
	
	}

}
