/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.resource;

import java.util.List;

import org.eclipse.stp.im.resources.IImResource;
import org.eclipse.stp.im.resources.IImResourceConfigurator;
import org.eclipse.stp.im.resources.datasources.DataSourceImResource;

public class SpagicResourceConfigurator implements IImResourceConfigurator {
	
	public String getConfiguration(List<IImResource> resourceList, String resourceType) {
		if (resourceType.equalsIgnoreCase(IImResource.DATA_SOURCE_IM_RESOURCE_TYPE)){
			return getConfigurationForDatasources(resourceList);
		}else{
			return notYetImplemented();
		}
	}
	
	protected String getConfigurationForDatasources(List<IImResource> resourceList) {
	
			StringBuffer sBuf = new StringBuffer();
			sBuf.append("<!-- INSERT THIS SECTION IN jndi.xml FILE UNDER SPAGIC_HOME\\conf\\ folder -->\n");

			for (IImResource imResource : resourceList){
				
				sBuf.append("<entry key=\"java:comp/env/jdbc/"+imResource.getId()+"\">\n"); 
				sBuf.append("  <bean id=\""+imResource.getId()+"\"\n"); 
				sBuf.append("      class=\"org.apache.commons.dbcp.BasicDataSource\"\n"); 
				sBuf.append("      destroy-method=\"close\">\n"); 
				sBuf.append("      <property name=\"driverClassName\" value=\""+imResource.getProperty(DataSourceImResource.DATASOURCE_DRIVER)+"\"/>\n"); 
				sBuf.append("      <property name=\"url\" value=\""+imResource.getProperty(DataSourceImResource.DATASOURCE_URL)+"\"/>\n"); 
				sBuf.append("      <property name=\"username\" value=\""+imResource.getProperty(DataSourceImResource.DATASOURCE_USER)+"\"/>\n"); 
				sBuf.append("      <property name=\"password\" value=\""+imResource.getProperty(DataSourceImResource.DATASOURCE_PASSWORD)+"\"/>\n"); 
				sBuf.append("  </bean>\n"); 
				sBuf.append("</entry>\n");
			}
			return sBuf.toString();
	   }

	
	protected String notYetImplemented(){
		return "<!-- NOT YET IMPLEMENTED -->";
	}
}
