/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.view;


import java.util.ArrayList;
import java.util.List;

public class CatalogObservableAttributeTreeElement extends ObservableAttributeTreeModel {
	protected List childCatalogs;
	protected List childRelevantData;

	

	
	
	public CatalogObservableAttributeTreeElement(String id, String name) {
		super(id, name);
		childCatalogs = new ArrayList();
		childRelevantData = new ArrayList();
	}
	
	
	public void addCatalog(CatalogObservableAttributeTreeElement catalogObservableAttributeTreeElement){
		
		this.childCatalogs.add(catalogObservableAttributeTreeElement);
		catalogObservableAttributeTreeElement.parent = this;	
	}
	
	public void addRelevantDataTreeElement(ObservableAttributeTreeElement observableAttributeTreeElement){
		
		this.childRelevantData.add(observableAttributeTreeElement);
		observableAttributeTreeElement.parent = this;	
	}
	
	
		
	
	/** Answer the total number of items the
	 * receiver contains. */
	public int size() {
		return   getChildCatalogs().size() + getChildRelevantData().size();
	}



	public List getChildRelevantData() {
		return childRelevantData;
	}



	public void setChildRelevantData(List childRelevantData) {
		this.childRelevantData = childRelevantData;
	}


	public List getChildCatalogs() {
		return childCatalogs;
	}


	public void setChildCatalogs(List childCatalogs) {
		this.childCatalogs = childCatalogs;
	}
	



	



	



	
}
