/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.view;

import java.util.Date;

public class ExtractionRuleObservableAttribute {
	
	private String id = null;
	private String name = null;
	private String description = null;
	
	private String expression = null;
	private String expressionLanguage = null;
	
	private boolean subjectToCondition = false;
	private String conditionExpression = null;
	private String conditionLanguage = null;
	private Date startDate = null;
	private Date endDate = null;
	
	public ExtractionRuleObservableAttribute(String id, String name, String expression, String expressionLanguage) {
		super();
		this.id = id;
		this.name = name;	
		this.expression = expression;
		this.expressionLanguage = expressionLanguage;
	}
	
	public ExtractionRuleObservableAttribute(String id, String name, String expression, String expressionLanguage, String conditionExpression, String conditionLanguage) {
		this(id,name,expression,expressionLanguage);
		this.subjectToCondition = true;
		this.conditionExpression = conditionExpression;
		this.conditionLanguage = conditionLanguage;
	}
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}

	public String getExpression() {
		return expression;
	}

	public void setExpression(String expression) {
		this.expression = expression;
	}

	public String getExpressionLanguage() {
		return expressionLanguage;
	}

	public void setExpressionLanguage(String expressionLanguage) {
		this.expressionLanguage = expressionLanguage;
	}

	public boolean isSubjectToCondition() {
		return subjectToCondition;
	}

	public void setSubjectToCondition(boolean subjectToCondition) {
		this.subjectToCondition = subjectToCondition;
	}

	public String getConditionExpression() {
		return conditionExpression;
	}

	public void setConditionExpression(String conditionExpression) {
		this.conditionExpression = conditionExpression;
	}

	public String getConditionLanguage() {
		return conditionLanguage;
	}

	public void setConditionLanguage(String conditionLanguage) {
		this.conditionLanguage = conditionLanguage;
	}

	public Date getStartDate() {
		return startDate;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	public Date getEndDate() {
		return endDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	

}
