/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.ui.view;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class ObservableAttributeTreeElement extends ObservableAttributeTreeModel {
	
	private Map<String,ExtractionRuleObservableAttribute> rules = null;
	
	//
	// RelevantData Could not exist without rules
	//
	
	public ObservableAttributeTreeElement(String id, String name){
		super (id, name);
		this.rules = new HashMap<String, ExtractionRuleObservableAttribute>();
	}
	
	public ObservableAttributeTreeElement(String id, 
								   String name, 
								   String ruleId, 
								   String ruleName,
								   String ruleExpression, 
								   String ruleLanguage){
		this(id,name);
		ExtractionRuleObservableAttribute aRuleElement = new ExtractionRuleObservableAttribute(ruleId, ruleName, ruleExpression, ruleLanguage);
		this.rules.put(aRuleElement.getId(),aRuleElement);
	}
	
	

	public Map<String, ExtractionRuleObservableAttribute> getRules() {
		return rules;
	}

	public void setRules(Map<String, ExtractionRuleObservableAttribute> rules) {
		this.rules = rules;
	}

	
	public void addRule(ExtractionRuleObservableAttribute aRuleElement) {
		this.rules.put(aRuleElement.getId(), aRuleElement);
	}
	
	
}
