/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.utils.preference;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.spagic.utils.SpagicUtils;
import org.spagic.utils.SpagicUtilsActivator;

/**
 * Class used to initialize default preference values.
 */
public class SpagicPreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = SpagicUtilsActivator.getDefault()
				.getPreferenceStore();
		
		store.setDefault(SpagicPreferenceConstants.P_SPAGIC_BASE_NAME_SPACE,"urn:eng:spagic:processes:");
		store.setDefault(SpagicPreferenceConstants.P_SPAGIC_SERVICE_MANAGER_HOST,"localhost");
		store.setDefault(SpagicPreferenceConstants.P_SPAGIC_DB_URL, "jdbc:mysql://localhost:3306/spagic");
		store.setDefault(SpagicPreferenceConstants.P_SPAGIC_DB_DRIVER, "com.mysql.jdbc.Driver");
		store.setDefault(SpagicPreferenceConstants.P_SPAGIC_DB_HIB_DIALECT, "org.hibernate.dialect.MySQLInnoDBDialect");
		store.setDefault(SpagicPreferenceConstants.P_SPAGIC_DB_USER, "spagic");
		store.setDefault(SpagicPreferenceConstants.P_SPAGIC_DB_PASSWORD, "spagic");
		store.setDefault(SpagicPreferenceConstants.P_SPAGIC_DB_SHOW_SQL, "true");
		
		store.setDefault(SpagicPreferenceConstants.P_SERVICE_REGISTRY_INQUIRY_URL, "http://localhost:8080/juddi/inquiry");
		store.setDefault(SpagicPreferenceConstants.P_SERVICE_REGISTRY_PUBLISH_URL, "http://localhost:8080/juddi/publish");

		// User to use to connect to service registry
		store.setDefault(SpagicPreferenceConstants.P_SERVICE_REGISTRY_USER, "eng");
		
		// Password to use to connect to service registry
		store.setDefault(SpagicPreferenceConstants.P_SERVICE_REGISTRY_PASSWORD, "eng");
		
		// Default Organization where to publish services
		store.setDefault(SpagicPreferenceConstants.P_SERVICE_REGISTRY_DEFAULT_ORG, "Engineering");
		
		store.setDefault(SpagicPreferenceConstants.P_GRAPH_VIZ_DOT_EXE, "C:/Programmi/ATT/Graphviz/bin/dot");
		
		store.setDefault(SpagicPreferenceConstants.P_GRAPH_VIZ_TEMP_FOLDER,"C:/tmp");
		
		store.setDefault(SpagicPreferenceConstants.P_SMX_GET_RESOURCES, "http://localhost:9092/getResources/");
	}

}
